#ifndef API_GLOBAL__H
#define API_GLOBAL__H

#include "OWIDeviceSpecific.h"
#include "OWIHighLevelFunctions.h"
#include "OWIBitFunctions.h"
#include "api_define.h"
/* Canapi.h*/


//char tmp_str[BUFFER_SIZE];

extern char canString[MAX_LENGTH_CAN_DATA];
extern char decrypt_uartString[BUFFER_SIZE];
extern char ring_buffer[MAX_INPUT][MAX_LENGTH_CAN_DATA];/*varianle for strorage all received CAN data*/
extern char setParameter[MAX_PARAMETER][MAX_LENGTH_PARAMETER]; /*storage of cut string */
extern char *ptr_setParameter[MAX_PARAMETER];
extern char tempstr[BUFFER_SIZE];/*Variable for debug*/
extern char uartString[BUFFER_SIZE]; /* variable for storage received a complete string via UART */
extern char keepAliveString[15];

extern int8_t can_init; /* variable to call CAN_Init function*/

extern uint8_t can_errorCode; /* error code for CAN-communication */
extern uint8_t general_errorCode; /*general error code */
extern uint8_t mailbox_errorCode; /* error code for Message Object Block */
extern uint8_t uart_errorCode; /* error code for UART-communication */

extern volatile unsigned char BufferFull;/*variable for Uart Interrupt*/
extern volatile unsigned char canReady; /* variable for CAN ISR */

extern volatile unsigned char timer0Ready;/*variable for Timer  Interrupt*/
extern volatile unsigned char timer1Ready;/*variable for Timer  Interrupt*/
extern volatile unsigned char timer0AReady;/*variable for Timer0 Output Compare A  Interrupt*/
extern volatile unsigned char timer0ASchedulerReady;/*variable for Timer0 Output Compare A  Interrupt*/
extern volatile unsigned char uartReady;/*variable for Uart Interrupt*/

extern uint8_t mob; /*variable  for Message Object Block in the interrupt routine*/
extern unsigned char nextCharPos;/* variable for the storage of data in serial string variable */

extern uint16_t subscribe_ID[MAX_LENGTH_SUBSCRIBE];
extern uint16_t subscribe_mask[MAX_LENGTH_SUBSCRIBE];


extern uint8_t ptr_buffer_in; /*pointer for write in ring_buffer*/
extern uint8_t ptr_buffer_out; /*pointer for read in ring_buffer*/
extern uint8_t ptr_subscribe; /* pointer of variable subscribe_ID and subscribe_mask */

extern uint8_t flag_pingActive; /* flag for PING mechanism */


extern const uint8_t serial_error_number[];
extern const char *serial_error[];

extern const uint8_t can_error_number[];
extern const char *can_error[];

extern const uint8_t mob_error_number[];
extern const char *mob_error[];

extern const uint8_t general_error_number[];
extern const char *general_error[];


//extern char buffer[BUFFER_SIZE];

extern char buffer[5];/*variable to store keyword "RECV"*/

extern uint16_t Voltages[8];/* current supply voltages of the board*/

/*variable to store values*/
extern char tmp_str[BUFFER_SIZE];

extern uint8_t cur_state;
extern uint8_t usercommand;

extern volatile uint16_t thigh;/*the maximum gas pressure*/
extern volatile uint16_t tlow;/*the minimum gas pressure*/

extern uint8_t res0, res1, res2, res3; /*parameter back to reading the voltage on ADC-channel*/

extern uint8_t NumDevicesFound;

extern uint8_t IDS_ALL[NUM_DEVICES][8];  /*Global variable to store the ID numbers of ALL devices*/
extern uint16_t IDS_ALL_VALUES[NUM_DEVICES][8];  /*Global variable to store the register values of ALL devices*/
extern uint8_t BUSES[5];

extern char PD;/*variable to check found devices*/
extern int8_t countDEV ;/*number of devices (initialized to 0)*/
extern int8_t countDEVbus;/*number of devices on the current bus (initialized to 0)*/

#endif


