/* The one_wire_ADC.h is a header file for the functions specific to analog to digital converter via one wire bus*/
#ifndef ONE_WIRE_ADC_H
#define ONE_WIRE_ADC__H
#include "api_define.h"
#include "api_global.h"
#include "api.h"
void read_WADC(struct uartStruct *ptr_uartStruct); /*this function contains all the functions that are necessary to
 * convert analog value to digital via one wire bus*/

int8_t ReadDevicesID (uint8_t *pins, int8_t showlist);/*this function list of all devices found in the one wire bus*/

int8_t ADCsInitialization(uint8_t *pins);/*this function initializes the analog to digital converter*/

int8_t MakeADCConversionOfAllDevices(uint8_t *pins);/*this function makes ADC converstaion o all find devices*/

int8_t FindFamilyDevicesAndGetValues(uint8_t *pins, int8_t countDev, uint8_t familyID);/*this function read the value fot temperatur of sensor, ADC and switch*/

int8_t ReadDualSwitches ( unsigned char bus, unsigned char * id, uint8_t *array_chn );/*this function reads the state of dual switch*/

int8_t ReadADCchannels(unsigned char bus, unsigned char * id, uint16_t *array_chn, const int8_t size );

void list_all_devices(struct uartStruct *ptr_uartStruct);/* this function contains all the functions that are necessary to
      list ID on all devices connected to one wire bus*/

#endif

